require 'Wyrm'
require 'Back'
require 'Explode'
require 'Helicopter'

Map = class:new()

back = Back:new()
wyrm = Wyrm:new()

function Map:init()

	self.scorch = {}
	
	self.score = 0

	self.people = {}
	self.choppers = {}
	
	self.explode = {}
	
	for i = 1, 3 do
	
		table.insert(self.choppers,Helicopter:new())
	
	end
	
	for i = 1, 10 do
	
		table.insert(self.people,{math.random(800),math.random(2),{math.random(255),math.random(255),math.random(255)}})
	
	end
	
	self.groundColor = {math.random(255),math.random(255),math.random(255)}
	self.groundNext = {math.random(255),math.random(255),math.random(255)}

end

function Map:update(dt)

	local removeChoppers = {}

	for i = 1, #self.choppers do
	
		self.choppers[i]:update(dt)
		
		if wyrm.position.y + wyrm.size.h > self.choppers[i].position.y and wyrm.position.y < self.choppers[i].position.y + self.choppers[i].size.h and wyrm.position.x + wyrm.size.w > self.choppers[i].position.x and wyrm.position.x < self.choppers[i].position.x + self.choppers[i].size.w then
		
			if wyrm.velocity.y > 200 or wyrm.velocity.x > 200 or wyrm.velocity.y < -200 or wyrm.velocity.x < -200 then
			
				table.insert(removeChoppers,i)
				local instance = planeExplode:play()
				table.insert(self.explode,Explode:new(self.choppers[i].position.x + self.choppers[i].size.w / 2,self.choppers[i].position.y + self.choppers[i].size.h / 2,100))
				self.score = self.score + 1
				
			end
		
		end
		
		if wyrm.behavior == "wait" then
		
			if love.mouse.isDown("r") then
			
				if love.mouse.getY()+5 >= self.choppers[i].position.y and love.mouse.getY()-5 <= self.choppers[i].position.y + self.choppers[i].size.h then
				
					if love.mouse.getX()+5 >= self.choppers[i].position.x and love.mouse.getX()-5 <= self.choppers[i].position.x + self.choppers[i].size.w then
					
						table.insert(removeChoppers,i)
						local instance = planeHit:play()
						table.insert(self.explode,Explode:new(self.choppers[i].position.x + self.choppers[i].size.w / 2,self.choppers[i].position.y + self.choppers[i].size.h / 2,100))
						self.score = self.score + 1
					
					end
				
				end
			
			end
		
		end
	
	end

	local groundCount = 1
	
	for i, v in ipairs(removeChoppers) do
	
		table.remove(self.choppers,v)
		table.insert(self.choppers,Helicopter:new())
	
	end

	for i = 1, #self.groundColor do

		if self.groundColor[i] > self.groundNext[groundCount] then
			self.groundColor[i] = self.groundColor[i] - 20 * dt
		elseif self.groundColor[i] < self.groundNext[groundCount] then
			self.groundColor[i] = self.groundColor[i] + 20 * dt
		end
		
		if self.groundNext[groundCount] + 20 > self.groundColor[i] and self.groundNext[groundCount] - 20 < self.groundColor[i] then
		
			self.groundNext[groundCount] = math.random(255)
		
		end
		
		groundCount = groundCount + 1
	
	end
	
	local removePeople = {}
	local removeBurn = {}
	local removeExplode = {}

	wyrm:update(dt)
	back:update(dt)
	
	for i = 1, #self.scorch do
	
		self.scorch[i][1] = self.scorch[i][1] - 50 * dt
		
		if self.scorch[i][1] < -5 then
		
			table.insert(removeBurn,i)
		
		end
	
	end
	
	for i, v in ipairs(removeBurn) do
	
		table.remove(self.scorch,v)
	
	end
	
	for i = 1, #self.people do
	
		if self.people[i][2] == 1 then
			self.people[i][1] = self.people[i][1] + 200 * dt
		elseif self.people[i][2] == 2 then
			self.people[i][1] = self.people[i][1] - 200 * dt
		end
		
		if self.people[i][1] > 820 or self.people[i][1] < -20 then
		
			if self.people[i][2] == 1 then
				self.people[i][1] = -(math.random(20,100))
			elseif self.people[i][2] == 2 then
				self.people[i][1] = (math.random(820,900))
			end
			
			self.people[i][3] = {math.random(255),math.random(255),math.random(255)}
		
		end
		
		if wyrm.position.y + wyrm.size.h > 410 and wyrm.position.y < 425 and wyrm.position.x + wyrm.size.w > self.people[i][1] and wyrm.position.x < self.people[i][1] + 5 then
		
			if wyrm.velocity.y > 200 then
			
				table.insert(removePeople,i)
				self.score = self.score + 1
				local instance = squishSound:play()
				table.insert(self.explode,Explode:new(self.people[i][1]+2,417,10))
				
			end
		
		end
		
		if wyrm.behavior == "wait" then
		
			if love.mouse.isDown("r") then
			
				if love.mouse.getY()+5 >= 410 and love.mouse.getY()-5 <= 425 then
				
					if love.mouse.getX()+5 >= self.people[i][1] and love.mouse.getX()-5 <= self.people[i][1]+5 then
					
						table.insert(self.explode,Explode:new(self.people[i][1]+2,417,10))
						local instance = explodeSound:play()
						self.score = self.score + 1
						table.insert(removePeople,i)
					
					end
				
				end
			
			end
		
		end
	
	end
	
	
	
	if wyrm.behavior == "wait" then
	
		if love.mouse.isDown("r") then
		
			if love.mouse.getY() + 5 >= 425 then
				
				table.insert(self.scorch,{love.mouse.getX()-2,love.mouse.getY()-2})
				
			end
		
		end
	
	end
	
	for i, v in ipairs(removePeople) do

		table.remove(self.people,v)
		table.insert(self.people,{math.random(800,1000),math.random(2),{math.random(255),math.random(255),math.random(255)}})
	
	end
	
	for i = 1, #self.explode do
	
		self.explode[i]:update(dt)
		
		if self.explode[i].timer > 10 then
		
			table.insert(removeExplode,i)
		
		end
	
	end
	
	for i, v in ipairs(removeExplode) do
	
		table.remove(self.explode,v)
	
	end
	
end

function Map:draw()

	back:draw()
	
	love.graphics.setColor(math.random(255),math.random(255),math.random(255))
	love.graphics.print(self.score,14,0)
	
	love.graphics.setColor(self.groundColor)
	love.graphics.rectangle('fill',0,425,800,25)
	
	for i = 1, #self.scorch do
	
		love.graphics.setColor(0,0,0,50)
		love.graphics.rectangle('fill',self.scorch[i][1],self.scorch[i][2],5,5)
	
	end
	
	for i = 1, #self.people do
	
		love.graphics.setColor(self.people[i][3])
		love.graphics.rectangle('fill',self.people[i][1],410,5,15)
	
	end
	
	for i = 1, #self.choppers do
	
		self.choppers[i]:draw()
	
	end
	
	wyrm:draw()
	
	if wyrm.behavior == "wait" then
		
		if love.mouse.isDown("r") then
			
			love.graphics.setColor(255,255,255,25)
			love.graphics.rectangle('fill',0,0,800,450)
			love.graphics.setColor(255,255,255,50)
			love.graphics.rectangle('fill',love.mouse.getX()-50,love.mouse.getY()-50,100,100)
			love.graphics.setColor(255,255,255,100)
			love.graphics.rectangle('fill',love.mouse.getX()-25,love.mouse.getY()-25,50,50)
			love.graphics.setColor(255,255,255,200)
			love.graphics.rectangle('fill',love.mouse.getX()-5,love.mouse.getY()-5,10,10)
			
		end
		
	end
	
	for i = 1, #self.explode do
	
		self.explode[i]:draw()
	
	end
	
end

function Map:mousepressed(button)
	wyrm:mousepressed(button)
end